# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.code_type import CodeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.id_type import IdType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.meta import Meta  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class Resource(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'meta': 'Meta',
        'implicit_rules': 'str',
        'language': 'str',
        'id_element': 'IdType',
        'resource_type': 'str',
        'language_element': 'CodeType',
        'implicit_rules_element': 'UriType',
        'id_base': 'str',
        'empty': 'bool',
        'structure_fhir_version_enum': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'meta': 'meta',
        'implicit_rules': 'implicitRules',
        'language': 'language',
        'id_element': 'idElement',
        'resource_type': 'resourceType',
        'language_element': 'languageElement',
        'implicit_rules_element': 'implicitRulesElement',
        'id_base': 'idBase',
        'empty': 'empty',
        'structure_fhir_version_enum': 'structureFhirVersionEnum',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, meta=None, implicit_rules=None, language=None, id_element=None, resource_type=None, language_element=None, implicit_rules_element=None, id_base=None, empty=None, structure_fhir_version_enum=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """Resource - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._meta = None
        self._implicit_rules = None
        self._language = None
        self._id_element = None
        self._resource_type = None
        self._language_element = None
        self._implicit_rules_element = None
        self._id_base = None
        self._empty = None
        self._structure_fhir_version_enum = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if meta is not None:
            self.meta = meta
        if implicit_rules is not None:
            self.implicit_rules = implicit_rules
        if language is not None:
            self.language = language
        if id_element is not None:
            self.id_element = id_element
        if resource_type is not None:
            self.resource_type = resource_type
        if language_element is not None:
            self.language_element = language_element
        if implicit_rules_element is not None:
            self.implicit_rules_element = implicit_rules_element
        if id_base is not None:
            self.id_base = id_base
        if empty is not None:
            self.empty = empty
        if structure_fhir_version_enum is not None:
            self.structure_fhir_version_enum = structure_fhir_version_enum
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this Resource.  # noqa: E501


        :return: The format_comments_pre of this Resource.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this Resource.


        :param format_comments_pre: The format_comments_pre of this Resource.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this Resource.  # noqa: E501


        :return: The format_comments_post of this Resource.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this Resource.


        :param format_comments_post: The format_comments_post of this Resource.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this Resource.  # noqa: E501


        :return: The id of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Resource.


        :param id: The id of this Resource.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def meta(self):
        """Gets the meta of this Resource.  # noqa: E501


        :return: The meta of this Resource.  # noqa: E501
        :rtype: Meta
        """
        return self._meta

    @meta.setter
    def meta(self, meta):
        """Sets the meta of this Resource.


        :param meta: The meta of this Resource.  # noqa: E501
        :type: Meta
        """

        self._meta = meta

    @property
    def implicit_rules(self):
        """Gets the implicit_rules of this Resource.  # noqa: E501


        :return: The implicit_rules of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._implicit_rules

    @implicit_rules.setter
    def implicit_rules(self, implicit_rules):
        """Sets the implicit_rules of this Resource.


        :param implicit_rules: The implicit_rules of this Resource.  # noqa: E501
        :type: str
        """

        self._implicit_rules = implicit_rules

    @property
    def language(self):
        """Gets the language of this Resource.  # noqa: E501


        :return: The language of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this Resource.


        :param language: The language of this Resource.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def id_element(self):
        """Gets the id_element of this Resource.  # noqa: E501


        :return: The id_element of this Resource.  # noqa: E501
        :rtype: IdType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this Resource.


        :param id_element: The id_element of this Resource.  # noqa: E501
        :type: IdType
        """

        self._id_element = id_element

    @property
    def resource_type(self):
        """Gets the resource_type of this Resource.  # noqa: E501


        :return: The resource_type of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this Resource.


        :param resource_type: The resource_type of this Resource.  # noqa: E501
        :type: str
        """
        allowed_values = ["Account", "ActivityDefinition", "AdverseEvent", "AllergyIntolerance", "Appointment", "AppointmentResponse", "AuditEvent", "Basic", "Binary", "BiologicallyDerivedProduct", "BodyStructure", "Bundle", "CapabilityStatement", "CarePlan", "CareTeam", "CatalogEntry", "ChargeItem", "ChargeItemDefinition", "Claim", "ClaimResponse", "ClinicalImpression", "CodeSystem", "Communication", "CommunicationRequest", "CompartmentDefinition", "Composition", "ConceptMap", "Condition", "Consent", "Contract", "Coverage", "CoverageEligibilityRequest", "CoverageEligibilityResponse", "DetectedIssue", "Device", "DeviceDefinition", "DeviceMetric", "DeviceRequest", "DeviceUseStatement", "DiagnosticReport", "DocumentManifest", "DocumentReference", "EffectEvidenceSynthesis", "Encounter", "Endpoint", "EnrollmentRequest", "EnrollmentResponse", "EpisodeOfCare", "EventDefinition", "Evidence", "EvidenceVariable", "ExampleScenario", "ExplanationOfBenefit", "FamilyMemberHistory", "Flag", "Goal", "GraphDefinition", "Group", "GuidanceResponse", "HealthcareService", "ImagingStudy", "Immunization", "ImmunizationEvaluation", "ImmunizationRecommendation", "ImplementationGuide", "InsurancePlan", "Invoice", "Library", "Linkage", "List", "Location", "Measure", "MeasureReport", "Media", "Medication", "MedicationAdministration", "MedicationDispense", "MedicationKnowledge", "MedicationRequest", "MedicationStatement", "MedicinalProduct", "MedicinalProductAuthorization", "MedicinalProductContraindication", "MedicinalProductIndication", "MedicinalProductIngredient", "MedicinalProductInteraction", "MedicinalProductManufactured", "MedicinalProductPackaged", "MedicinalProductPharmaceutical", "MedicinalProductUndesirableEffect", "MessageDefinition", "MessageHeader", "MolecularSequence", "NamingSystem", "NutritionOrder", "Observation", "ObservationDefinition", "OperationDefinition", "OperationOutcome", "Organization", "OrganizationAffiliation", "Parameters", "Patient", "PaymentNotice", "PaymentReconciliation", "Person", "PlanDefinition", "Practitioner", "PractitionerRole", "Procedure", "Provenance", "Questionnaire", "QuestionnaireResponse", "RelatedPerson", "RequestGroup", "ResearchDefinition", "ResearchElementDefinition", "ResearchStudy", "ResearchSubject", "RiskAssessment", "RiskEvidenceSynthesis", "Schedule", "SearchParameter", "ServiceRequest", "Slot", "Specimen", "SpecimenDefinition", "StructureDefinition", "StructureMap", "Subscription", "Substance", "SubstanceNucleicAcid", "SubstancePolymer", "SubstanceProtein", "SubstanceReferenceInformation", "SubstanceSourceMaterial", "SubstanceSpecification", "SupplyDelivery", "SupplyRequest", "Task", "TerminologyCapabilities", "TestReport", "TestScript", "ValueSet", "VerificationResult", "VisionPrescription"]  # noqa: E501
        if resource_type not in allowed_values:
            raise ValueError(
                "Invalid value for `resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(resource_type, allowed_values)
            )

        self._resource_type = resource_type

    @property
    def language_element(self):
        """Gets the language_element of this Resource.  # noqa: E501


        :return: The language_element of this Resource.  # noqa: E501
        :rtype: CodeType
        """
        return self._language_element

    @language_element.setter
    def language_element(self, language_element):
        """Sets the language_element of this Resource.


        :param language_element: The language_element of this Resource.  # noqa: E501
        :type: CodeType
        """

        self._language_element = language_element

    @property
    def implicit_rules_element(self):
        """Gets the implicit_rules_element of this Resource.  # noqa: E501


        :return: The implicit_rules_element of this Resource.  # noqa: E501
        :rtype: UriType
        """
        return self._implicit_rules_element

    @implicit_rules_element.setter
    def implicit_rules_element(self, implicit_rules_element):
        """Sets the implicit_rules_element of this Resource.


        :param implicit_rules_element: The implicit_rules_element of this Resource.  # noqa: E501
        :type: UriType
        """

        self._implicit_rules_element = implicit_rules_element

    @property
    def id_base(self):
        """Gets the id_base of this Resource.  # noqa: E501


        :return: The id_base of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this Resource.


        :param id_base: The id_base of this Resource.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def empty(self):
        """Gets the empty of this Resource.  # noqa: E501


        :return: The empty of this Resource.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this Resource.


        :param empty: The empty of this Resource.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def structure_fhir_version_enum(self):
        """Gets the structure_fhir_version_enum of this Resource.  # noqa: E501


        :return: The structure_fhir_version_enum of this Resource.  # noqa: E501
        :rtype: str
        """
        return self._structure_fhir_version_enum

    @structure_fhir_version_enum.setter
    def structure_fhir_version_enum(self, structure_fhir_version_enum):
        """Sets the structure_fhir_version_enum of this Resource.


        :param structure_fhir_version_enum: The structure_fhir_version_enum of this Resource.  # noqa: E501
        :type: str
        """
        allowed_values = ["DSTU2", "DSTU2_HL7ORG", "DSTU2_1", "DSTU3", "R4", "R5"]  # noqa: E501
        if structure_fhir_version_enum not in allowed_values:
            raise ValueError(
                "Invalid value for `structure_fhir_version_enum` ({0}), must be one of {1}"  # noqa: E501
                .format(structure_fhir_version_enum, allowed_values)
            )

        self._structure_fhir_version_enum = structure_fhir_version_enum

    @property
    def resource(self):
        """Gets the resource of this Resource.  # noqa: E501


        :return: The resource of this Resource.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this Resource.


        :param resource: The resource of this Resource.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this Resource.  # noqa: E501


        :return: The boolean_primitive of this Resource.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this Resource.


        :param boolean_primitive: The boolean_primitive of this Resource.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this Resource.  # noqa: E501


        :return: The date_time of this Resource.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this Resource.


        :param date_time: The date_time of this Resource.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this Resource.  # noqa: E501


        :return: The primitive of this Resource.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this Resource.


        :param primitive: The primitive of this Resource.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Resource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
